org.cpsolver.studentsct.heuristics.studentord

## Class StudentChoiceOrder

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.studentord.StudentChoiceOrder

- All Implemented Interfaces:
    Comparator<Student>, StudentOrder
  Direct Known Subclasses:
    StudentByRequestDate, StudentChoiceRealFirstOrder, StudentGroupsChoiceRealFirstOrder

      public class StudentChoiceOrder
      extends Object
      implements StudentOrder, Comparator<Student>

  Return the given set of students in an order of average number of choices of each student (students with more choices first).
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentChoiceOrder(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `avgNrChoices(Student student)` Average number of choices for each student
    `int` | `compare(Student s1, Student s2)`
    `Request.RequestPriority` | `getRequestPriority()`
    `boolean` | `isCriticalOnly()`
    `boolean` | `isReverse()` Is order reversed
    `List<Student>` | `order(List<Student> students)` Order the given list of students
    `void` | `setCriticalOnly(boolean critOnly)`
    `void` | `setRequestPriority(Request.RequestPriority priority)`
    `void` | `setReverse(boolean reverse)` Set reverse order

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Constructor Detail

    - #### StudentChoiceOrder

          public StudentChoiceOrder(DataProperties config)

  - ### Method Detail

    - #### isReverse

          public boolean isReverse()

      Is order reversed
      Returns:
        true if the order is reversed

    - #### setReverse

          public void setReverse(boolean reverse)

      Set reverse order
      Parameters:
        `reverse` - true if students are to be in a reversed order

    - #### isCriticalOnly

          public boolean isCriticalOnly()

    - #### setCriticalOnly

          public void setCriticalOnly(boolean critOnly)

    - #### setRequestPriority

          public void setRequestPriority(Request.RequestPriority priority)

    - #### getRequestPriority

          public Request.RequestPriority getRequestPriority()

    - #### order

          public List<Student> order(List<Student> students)

      Order the given list of students
      Specified by:
        `order` in interface `StudentOrder`
      Parameters:
        `students` - input list of students
      Returns:
        new list of students, ordered by this criterion

    - #### compare

          public int compare(Student s1,
                             Student s2)

      Specified by:
        `compare` in interface `Comparator<Student>`

    - #### avgNrChoices

          public double avgNrChoices(Student student)

      Average number of choices for each student
      Parameters:
        `student` - given student
      Returns:
        average number of choices of the given student